;################################################################################
;#										#
;# mode 7 engine 40x24 text							#
;# copyright (c) 2009-2010 Joerg Wolfram (joerg@jcwolfram.de)			#
;#										#
;# This library is free software; you can redistribute it and/or		#
;# modify it under the terms of the GNU Lesser General Public			#
;# License as published by the Free Software Foundation; either			#
;# version 3 of the License, or (at your option) any later version.		#
;#										#
;# This library is distributed in the hope that it will be useful,		#
;# but WITHOUT ANY WARRANTY; without even the implied warranty of		#
;# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	See the GNU		#
;# Lesser General Public License for more details.				#
;#										#
;# You should have received a copy of the GNU Lesser General Public		#
;# License along with this library; if not, write to the			#
;# Free Software Foundation, Inc., 59 Temple Place - Suite 330,			#
;# Boston, MA 02111-1307, USA.							#
;#										#
;################################################################################

vint_lc3_fill:
		ldi	ZH,0x0a
		sbrc	vline_l,0
		ldi	ZH,0x05
		rjmp	vint_lc3_bla_0

vint_lc3_blank:	clr	ZH
		sbic	GPIOR0,7
		ldi	ZH,0x0f

vint_lc3_bla_0:	ldi	YL,0x80
		out	DPORT,ZH		;set to white
		ldi	XL,79
vint_lc3_bla_1:	out	DPIN,YL			;CP
		dec	XL
		out	DPIN,YL			;/CP
		brne	vint_lc3_bla_1
		sts	vsys_lastnib,ZH
		rjmp	vint_lc3_end

vint_lc3_sblank:	clr	ZH
		sbic	GPIOR0,7
		ldi	ZH,0x0f
		ldi	YL,0x80
		out	DPORT,ZH		;set to white
		ldi	XL,1
		rjmp	vint_lc3_bla_1

vint_lc3_fblank:
		clr	ZH
		sbic	GPIOR0,7
		ldi	ZH,0x0f

		ldi	ZL,0x80
		out	DPORT,ZH		;set to white
		ldi	XL,79
vint_lc3_fbl_1:	out	DPIN,ZL			;CP
		dec	XL
		out	DPIN,ZL			;/CP
		brne	vint_lc3_fbl_1
		ldi	ZH,0x20
		sbic	GPIOR0,7
		ldi	ZH,0x2f
		sts	vsys_lastnib,ZH
		rjmp	vint_lc3_end

;-------------------------------------------------------------------------------
; video output
;-------------------------------------------------------------------------------
vint_lc3:	cbi	DPORT,4			;enable display

;count up line counter
		ldi	YL,0x80
		lds	ZH,vsys_lastnib
		out	DPORT,ZH
		sbi	DPORT,6			;set LD
		nop
		out	DPIN,YL			;CP
		nop
		out	DPIN,YL			;/CP
		nop
		cbi	DPORT,6			;clear LD

;-------------------------------------------------------------------------------
;check if line is image
;-------------------------------------------------------------------------------
		mov	ZH,vline_l
		cpi	ZH,0
		breq	vint_lc3_fblank		;first blank line
		cpi	ZH,24
		brcs	vint_lc3_sblank		;upper blank view
		cpi	ZH,216
		brcs	vint_lc3_10
		breq	vint_lc3_blank_x
		cpi	ZH,240
		brcs	vint_lc3_sblank
		jmp	vint_frame

vint_lc3_blank_x:	rjmp	vint_lc3_blank

;-------------------------------------------------------------------------------
; LCD output
;-------------------------------------------------------------------------------
vint_lc3_10:	sbic	GPIOR0,fast_flag
		rjmp	vint_lc3_sblank
		clr	ZH
		sbic	GPIOR0,7
		ldi	ZH,0x0f

		ldi	YL,0x80
		out	DPORT,ZH		;set to border
		ldi	XL,8
vint_lc3_12:	out	DPIN,YL			;CP
		nop
		out	DPIN,YL			;/CP
		dec	XL
		brne	vint_lc3_12

		lds	XL,vsys_rampos_l	;RAM pointer
		lds	XH,vsys_rampos_h
		mov	ZL,vline_l		;
		subi	ZL,24
		andi	ZL,0x07
		cpi	ZL,0x07
		in	YL,SREG
		bst	YL,1			;save flag

		ldi	ZH,HIGH(vsys_ctable80*2)
		add	ZH,ZL

		ldi	YL,0x80			;CP pin
		push	r20			;save additional registers
		push	r21

		ldi	r21,64			;chars to do * 2

vint_lc3_14:	ld	ZL,X			;2 get char
		sbrc	ZL,6			;1
		rjmp	vint_lc3_15		;1 bit 6 is set
		lpm	r20,Z			;3 get pixline
		adiw	XL,1			;2

		sbis	GPIOR0,7
		com	r20

		mov	YH,r20			;1 copy pixline for second nibble
		swap	YH
		andi	YH,0x0f			;1 mask unused bits
		out	DPORT,YH		;1 out 4 bits
		out	DPIN,YL			;CP
		andi	r20,0x0f		;1 mask
		out	DPIN,YL			;/CP
		out	DPORT,r20
		out	DPIN,YL			;CP
		subi	r21,2
		out	DPIN,YL			;/CP
		brne	vint_lc3_14

vint_lc3_15:	subi	r21,0xf9		;+5
		clr	ZH
		sbic	GPIOR0,7
		ldi	ZH,0x0f
		out	DPORT,ZH

vint_lc3_17:	out	DPIN,YL			;CP
		nop
		out	DPIN,YL			;/CP
		dec	r21
		brne	vint_lc3_17
		sts	vsys_lastnib,ZH
		pop	r21
		pop	r20

		brts	vint_lc3_20

		jmp	vsys_kir_end

vint_lc3_20:	adiw	XL,1
		sts	vsys_rampos_l,XL
		sts	vsys_rampos_h,XH
;------------------------------------------------------------------------------
;the keyboard routine
;09 no char from keyboard
;26 key, but released
;43 key, state 1
;------------------------------------------------------------------------------
vint_lc3_end:	jmp	vsys_keyb

